function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { makeStyles } from '@material-ui/core/styles';
import { useAuth } from 'base-shell/lib/providers/Auth';
import { useMenu } from 'material-ui-shell/lib/providers/Menu';
import { useTheme as useAppTheme } from 'material-ui-shell/lib/providers/Theme';
import clsx from 'clsx';
import { Avatar, IconButton, List, ListItem, ListItemAvatar, ListItemSecondaryAction, ListItemText, Paper } from '@material-ui/core';
import { ChevronLeft, ChevronRight, ChromeReaderMode, Person as PersonIcon, ArrowDropDown as ArrowDropDownIcon, ArrowDropUp as ArrowDropUpIcon, Brightness4 as Brightness4Icon, BrightnessHigh as BrightnessHighIcon } from '@material-ui/icons';
var useStyles = makeStyles(function (theme) {
  return {
    paper: {
      backgroundColor: theme.palette.primary.dark,
      margin: 0,
      padding: 0
    },
    listItem: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    icon: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    toolbar: _extends({
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'flex-end',
      padding: theme.spacing(0, 2)
    }, theme.mixins.toolbar)
  };
});

var MenuHeader = function MenuHeader() {
  var _useAuth = useAuth(),
      auth = _useAuth.auth;

  var _useAppTheme = useAppTheme(),
      toggleThisTheme = _useAppTheme.toggleThisTheme,
      isDarkMode = _useAppTheme.isDarkMode,
      isRTL = _useAppTheme.isRTL;

  var authData = auth;
  var classes = useStyles();

  var _useMenu = useMenu(),
      toggleThis = _useMenu.toggleThis,
      isDesktop = _useMenu.isDesktop,
      isMiniMode = _useMenu.isMiniMode,
      isMenuOpen = _useMenu.isMenuOpen,
      isMiniSwitchVisibility = _useMenu.isMiniSwitchVisibility,
      isAuthMenuOpen = _useMenu.isAuthMenuOpen;

  var isAuthenticated = auth.isAuthenticated;

  var AvatarConstructor = function AvatarConstructor(_ref) {
    var src = _ref.src,
        alt = _ref.alt,
        avatar = _ref.avatar;
    return /*#__PURE__*/React.createElement(ListItemAvatar, {
      onClick: function onClick() {
        return toggleThis('isAuthMenuOpen');
      }
    }, /*#__PURE__*/React.createElement(Avatar, {
      src: src,
      alt: alt
    }, " ", avatar, " "));
  };

  return /*#__PURE__*/React.createElement(Paper, {
    square: true,
    className: classes.paper
  }, isMiniMode && isAuthenticated && /*#__PURE__*/React.createElement("div", {
    className: classes.toolbar
  }), /*#__PURE__*/React.createElement(List, {
    className: clsx(!isAuthenticated && classes.toolbar)
  }, !isMiniMode && /*#__PURE__*/React.createElement(ListItem, {
    className: classes.listItem
  }, isAuthenticated && (authData.photoURL ? AvatarConstructor({
    src: authData.photoURL,
    alt: "user"
  }) : AvatarConstructor({
    avatar: authData.displayName ? authData.displayName[0].toUpperCase() : /*#__PURE__*/React.createElement(PersonIcon, null)
  })), /*#__PURE__*/React.createElement(ListItemSecondaryAction, null, /*#__PURE__*/React.createElement(IconButton, {
    onClick: function onClick() {
      toggleThisTheme('isDarkMode');
    }
  }, isDarkMode ? /*#__PURE__*/React.createElement(BrightnessHighIcon, {
    classes: {
      root: classes.icon
    }
  }) : /*#__PURE__*/React.createElement(Brightness4Icon, {
    classes: {
      root: classes.icon
    }
  })), isDesktop && /*#__PURE__*/React.createElement(React.Fragment, null, isMiniSwitchVisibility && /*#__PURE__*/React.createElement(IconButton, {
    onClick: function onClick() {
      toggleThis('isMiniMode', true);
      toggleThis('isMenuOpen', false);
    }
  }, /*#__PURE__*/React.createElement(ChromeReaderMode, {
    classes: {
      root: classes.icon
    }
  })), /*#__PURE__*/React.createElement(IconButton, {
    color: "inherit",
    onClick: function onClick() {
      toggleThis('isMenuOpen', false);
    }
  }, isRTL ? /*#__PURE__*/React.createElement(ChevronRight, {
    classes: {
      root: classes.icon
    }
  }) : /*#__PURE__*/React.createElement(ChevronLeft, {
    classes: {
      root: classes.icon
    }
  })), ' '))), isAuthenticated && /*#__PURE__*/React.createElement(ListItem, {
    onClick: function onClick() {
      toggleThis('isAuthMenuOpen');
    }
  }, !isMenuOpen && isMiniMode && isDesktop && (authData.photoURL ? AvatarConstructor({
    src: authData.photoURL,
    alt: "user"
  }) : AvatarConstructor({
    avatar: authData.displayName ? authData.displayName[0].toUpperCase() : /*#__PURE__*/React.createElement(PersonIcon, null)
  })), !isMiniMode && /*#__PURE__*/React.createElement(ListItemText, {
    classes: {
      primary: classes.listItem,
      secondary: classes.listItem
    },
    style: {
      marginLeft: !isMenuOpen && isDesktop && authData.photoURL ? 7 : undefined
    },
    primary: authData.displayName,
    secondary: authData.email
  }), isMenuOpen && /*#__PURE__*/React.createElement(ListItemSecondaryAction, {
    onClick: function onClick() {
      toggleThis('isAuthMenuOpen');
    }
  }, /*#__PURE__*/React.createElement(IconButton, null, isAuthMenuOpen ? /*#__PURE__*/React.createElement(ArrowDropUpIcon, {
    classes: {
      root: classes.icon
    }
  }) : /*#__PURE__*/React.createElement(ArrowDropDownIcon, {
    classes: {
      root: classes.icon
    }
  }))))));
};

export default MenuHeader;