function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import ResponsiveMenu from '../ResponsiveMenu/ResponsiveMenu';
import Scrollbar from 'material-ui-shell/lib/components/Scrollbar/Scrollbar';
import SelectableMenuList from 'material-ui-shell/lib/containers/SelectableMenuList';
import { useAddToHomeScreen } from 'base-shell/lib/providers/AddToHomeScreen';
import { useAuth } from 'base-shell/lib/providers/Auth';
import { useConfig } from 'base-shell/lib/providers/Config';
import { useHistory, useRouteMatch } from 'react-router-dom';
import { useIntl } from 'react-intl';
import { useLocale } from 'base-shell/lib/providers/Locale';
import { useMenu } from 'material-ui-shell/lib/providers/Menu';
import { useTheme as useAppTheme } from 'material-ui-shell/lib/providers/Theme';

var Menu = function Menu(props) {
  var intl = useIntl();
  var history = useHistory();
  var match = useRouteMatch();
  var auth = useAuth();
  var menuContext = useMenu();
  var a2HSContext = useAddToHomeScreen();

  var _ref = menuContext || {},
      toggleThis = _ref.toggleThis,
      isMiniMode = _ref.isMiniMode,
      isMiniSwitchVisibility = _ref.isMiniSwitchVisibility;

  var _useConfig = useConfig(),
      appConfig = _useConfig.appConfig;

  var _useLocale = useLocale(),
      setLocale = _useLocale.setLocale,
      _useLocale$locale = _useLocale.locale,
      locale = _useLocale$locale === void 0 ? 'en' : _useLocale$locale;

  var _ref2 = appConfig || {},
      menu = _ref2.menu;

  var _ref3 = menu || {},
      MenuHeader = _ref3.MenuHeader,
      getMenuItems = _ref3.getMenuItems;

  var themeContext = useAppTheme();
  var menuItems = getMenuItems(_extends({
    intl,
    locale,
    updateLocale: setLocale,
    menuContext,
    themeContext,
    appConfig,
    a2HSContext,
    auth
  }, props)).filter(function (item) {
    return item.visible !== false;
  });
  var index = match ? match.path : '/';

  var handleChange = function handleChange(event, index) {
    if (index !== undefined) {
      toggleThis('isMobileMenuOpen', false);
    }

    if (index !== undefined && index !== Object(index)) {
      history.push(index);
    }
  };

  var isRTL = themeContext.isRTL;
  return /*#__PURE__*/React.createElement(ResponsiveMenu, null, /*#__PURE__*/React.createElement("div", {
    style: {
      direction: isRTL ? 'rtl' : 'ltr'
    }
  }, MenuHeader && /*#__PURE__*/React.createElement(MenuHeader, null)), /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      height: '100%',
      direction: isRTL ? 'rtl' : 'ltr'
    }
  }, /*#__PURE__*/React.createElement(Scrollbar, {
    style: {
      flex: 1
    }
  }, /*#__PURE__*/React.createElement(SelectableMenuList, {
    key: isMiniSwitchVisibility + themeContext.isRTL,
    onIndexChange: handleChange,
    useMinified: isMiniMode,
    items: menuItems,
    index: index
  }))));
};

export default Menu;